#Standalone installation
##Web server Requirements
1. `yum install nginx`
2. `systemctl start nginx`


## Database Requirements
1. Postgresql 11 and above (currently we are using 15 )
   yum install -y https://download.postgresql.org/pub/repos/yum/reporpms/EL-8-x86_64/pgdg-redhat-repo-latest.noarch.rpm
   dnf module disable postgresql -y
   yum -y install postgresql15-server postgresql15-contrib prefix_15 ip4r_15
   /usr/pgsql-15/bin/postgresql11-setup initdb
2. adduser -c -s webbackend
 
## Python Requirements
1. Python >= 3.6  (currently we are using puthon 3.6.8)
2. PIP => 9.0.1
3. install falcon_rest from git:
    git clone http://stash.denovolab.com/scm/af/falcon_rest.git
    cd falcon_rest 
    python3 setup.py install
4. see requirements.txt

##installation steps
git clone 
go to the clonded repository and:
1. pip3 install -r requirements.txt
2. python3 setup.py install
## Running api
Api will create /opt/denovo_v6/api_dnl directory.
from this directory you can use /usr/local/bin/api_dnl_run to start api, and check if everything is ok
api also has few other instances to start,  api_dnl_worker, and api_dnl_beat.
we are usind systemd to manage these instances, those are like this:
 - dnl_api_dnl
 - dnl_api_dnl_worker@0
 - dnl_api_dnl_worker@1
 - dnl_api_dnl_worker@2
 - dnl_api_dnl_beat
 Also this install is system install, meaning that install command will put libraries into /usr/local/python3.6/...  and binaries into /usr/local/bin
 api also need postgresql database to run, so you should install it from previous steps, and do next commands to create database, tables and some base data.
 systemd service files are provided in systemd directory.
 commands to run with systemd:
  - systemctl start dnl_api_dnl dnl_api_dnl_worker@0 dnl_api_dnl_worker@1 dnl_api_dnl_worker@2 dnl_api_dnl_beat
  
 creating database:
 psql -U postgres -c "create database class4_dnl"
 psql -U postgres -c "create user webbackend"
 psql -U webbackend -d class4_dnl < schema/schema.sql
 psql -U webbackend -d class4_dnl < schema/class4_update_record.sql
 psql -U webbackend -d class4_dnl < schema/data.sql
 
 in the /opt/denovo_v6/api_dnl:
 - you need to change api.ini api_host must be external ip address or dns name of api
 - api_schema depend of nginx "http" ot "https" configuration
 
 -- installation will create following entry points for api_dnl:
 
    `/usr/local/bin/api_dnl_run`  <-- run gunicorn web service
    `/usr/local/bin/api_dnl_worker` <-- exec celery run task service
    `/usr/local/bin/api_dnl_beat` <-- exec celery schedule task service

api can be read from swagger, once it is up and running it will provide http://ip.or.url/api_dnl/v1/swagger.json  which then can be used to load in swagger
we have  http://swagger.denovolab.com which can be used for this.

 #### Update database #########
4. `sudo /usr/local/bin/alembic upgrade head`

